#ifndef _CLASS_COPY_C_
#define _CLASS_COPY_C_

//
//  File Copy.C 
//
//  September 12 1994 - September 1996
//
//  Frederic Boulanger, Supelec
//
//  Internet: Frederic.Boulanger@supelec.fr
//  Mail:   Supelec - Service Informatique
//          Plateau de Moulon
//          91192 Gif-sur-Yvette Cedex
//          France
//  Voice:  (33 1) 69 85 14 91
//  Fax:    (33 1) 69 85 12 34
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1996.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

#include "Copy.H"

template<class sigType>
  Copy<sigType>::Copy(const char* name, const bool sched)
                : Synchronous(name, sched),
                  finput(this,"input"),
                  foutput(this,"output")
  {
  }

template<class sigType>
  InSignal<sigType>& Copy<sigType>::input() {
    return finput;
  }

template<class sigType>
  OutSignal<sigType>& Copy<sigType>::output() {
    return foutput;
  }

template<class sigType>
  const InputSignal** Copy<sigType>::inSigList() const {
    const InputSignal** sigList;
    sigList = (const InputSignal**) new (InputSignal*[2]);
    sigList[0] = &finput;
    sigList[1] = 0;
    return sigList;
  }

template<class sigType>
  const OutputSignal** Copy<sigType>::outSigList() const {
    const OutputSignal** sigList;
    sigList = (const OutputSignal**) new (OutputSignal*[2]);
    sigList[0] = &foutput;
    sigList[1] = 0;
    return sigList;
  }

template<class sigType>
  void Copy<sigType>::resetOutputs()  {
    foutput.value().reset();
  }

template<class sigType>
  void Copy<sigType>::setInputs()  {
    finput.update();
  }

template<class sigType>
  void Copy<sigType>::resetInputs()  {
    finput.value().reset();
  }

template<class sigType>
  void Copy<sigType>::activate()  {
    foutput.value() = finput.value();
  }

template<class sigType>
  void Copy<sigType>::backup()  {
  }

template<class sigType>
  void Copy<sigType>::restore()  {
  }

#endif

