#ifndef _CLASS_COPY_H_
#define _CLASS_COPY_H_

//  File Copy.H 
//
//  September 12 1994 - September 1996
//
//	Frederic Boulanger, Supelec
//
//	Internet:	Frederic.Boulanger@supelec.fr
//	Mail:		  Supelec - Service Informatique
//			      Plateau de Moulon
//				    91192 Gif-sur-Yvette Cedex
//			      France
//	Voice:	(33 1) 69 85 14 84
//	Fax:	  (33 1) 69 85 12 34
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1996.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

#include "Synchronous.H"
#include "Signal.H"

class PureCopy : virtual public Synchronous  {
	public:
		PureCopy(const char* name = "Copy", const bool sched = true);
		virtual PureInSignal& input();
		virtual PureOutSignal& output();
		const InputSignal** inSigList() const;
		const OutputSignal** outSigList() const;
		void resetOutputs();
		void resetInputs();
		void setInputs();
		void activate();
		virtual void backup();
		virtual void restore();
	private:
		PureInSignal finput;
		PureOutSignal foutput;
		PureCopy(const PureCopy&);
};

template<class sigType>
	class Copy : virtual public Synchronous {
		public:
			Copy(const char* name = "Copy", const bool sched = true);
			virtual InSignal<sigType>& input();
			virtual OutSignal<sigType>& output();
			const InputSignal** inSigList() const;
			const OutputSignal** outSigList() const;
			void resetOutputs();
			void resetInputs();
			void setInputs();
			void activate();
			virtual void backup();
			virtual void restore();
		private:
			InSignal<sigType> finput;
			OutSignal<sigType> foutput;
			Copy(const Copy<sigType>&);
	};

#ifdef __GNUG__
#include "Copy.C"
#endif

#endif

