#if defined(__GNUG__) && defined(_USE_PRAGMAS_)
#pragma implementation
#endif

#include "libSync.H"
#include "ampli.H"

int main() {
  cerr << "This is a test program for libSync." << endl;
  cerr << "Two differential amplifiers (s = 10*(a-b)) are" << endl;
  cerr << "connected. Input a of the first amp and input b of" << endl;
  cerr << "the second are the inputs of the system. Input b of" << endl;
  cerr << "the first amp is output s of the second, and input a" << endl;
  cerr << "of the second is connected to output s of the first" << endl;
  cerr << "through a delay." << endl;
  cerr << "       |\\         " << endl;
  cerr << "  a  --| \\        " << endl;
  cerr << "       |1 \\       " << endl;
  cerr << "       |  /---- s " << endl;
  cerr << "    /--| /  |     " << endl;
  cerr << "    |  |/   |     " << endl;
  cerr << "    |     Delay   " << endl;
  cerr << "    \\----\\  |     " << endl;
  cerr << "         |  |     " << endl;
  cerr << "    /----)--/     " << endl;
  cerr << "    |    |        " << endl;
  cerr << "    |    \\----\\   " << endl;
  cerr << "    |  |\\     |   " << endl;
  cerr << "    \\--| \\    |   " << endl;
  cerr << "       |2 \\   |   " << endl;
  cerr << "       |  /---/   " << endl;
  cerr << "  b  --| /        " << endl;
  cerr << "       |/         " << endl;
  cerr << endl;
  cerr << "Because of the delay, the system is unstable." << endl << endl;
  SScheduler myClock("Clock", true);
  ampli A1("Ampli 1");
  ampli A2("Ampli 2");
  Delay<int> d(0,"Retard");
  InputModule<int> A("a : ", "", false, "Entree1");
  InputModule<int> B("b : ", "", false, "Entree2");
  OutputModule<int> S("s = ", true, "\n", "Sortie");

  A1.a() << A.input();
  A1.b() << A2.s();
  A2.a() << d.output();
  d.input() << A1.s();
  A2.b() << B.input();
  S.probe() << A1.s();

  while(myClock.tick())
    ;
  return 0;
}
