//
//  File PureCopy.C 
//
//  September 12 1994 - September 1996
//
//  Frederic Boulanger, Supelec
//
//  Internet: Frederic.Boulanger@supelec.fr
//  Mail:   Supelec - Service Informatique
//        Plateau de Moulon
//        91192 Gif-sur-Yvette Cedex
//        France
//  Voice:  (33 1) 69 85 14 84
//  Fax:  (33 1) 69 85 12 34
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1996.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//

#include "Copy.H"

PureCopy::PureCopy(const char* name, const bool sched)
        : Synchronous(name, sched),
          finput(this,"input"),
          foutput(this,"output")
{
}

PureInSignal& PureCopy::input() {
  return finput;
}

PureOutSignal& PureCopy::output() {
  return foutput;
}

const InputSignal** PureCopy::inSigList() const {
    const InputSignal** sigList;
    sigList = (const InputSignal**) new (InputSignal*[2]);
    sigList[0] = &finput;
    sigList[1] = 0;
    return sigList;
  }

const OutputSignal** PureCopy::outSigList() const {
  const OutputSignal** sigList;
    sigList = (const OutputSignal**) new (OutputSignal*[2]);
    sigList[0] = &foutput;
    sigList[1] = 0;
    return sigList;
  }

void PureCopy::resetOutputs()  {
  foutput.value().reset();
}

void PureCopy::setInputs()  {
  finput.update();
}

void PureCopy::resetInputs()  {
  finput.value().reset();
}

void PureCopy::activate()  {
  foutput.value() = finput.value();
}

void PureCopy::backup()  {
}

void PureCopy::restore()  {
}

