#ifndef _CLASS_QSORT_C_
#define _CLASS_QSORT_C_

//
//  File QSort.C
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "QSort.H"
#include "Array.H"

// Quick sort
//

template<class T>
  QSort<T>::QSort(Array<T>& a)
           : a(a)
{
}

template<class T>
  QSort<T>::~QSort() {
}

template<class T>
  Array<T>& QSort<T>::array() {
  return a;
}

template<class T>
  void QSort<T>::sort() {
  qsort(0, a.size() - 1);
}

template<class T>
  void QSort<T>::qsort(const int i, const int j) {
  if (i < j) {
    int k = pivot(i, j);
    qsort(i, k-1);
    qsort(k+1, j);
  }
}

template<class T>
  int QSort<T>::pivot(const int i, const int j) {
  int k = j;
  int l = i+1;
  
  while(l <= k) {
    while(greater(a[k], a[i]))
      k--;
    while((l <= j) && (greateq(a[i], a[l])))
      l++;
    if (l < k)
      a.swap(l++,k--);
  }
  a.swap(i,k);
  return k;
}

template<class T>
  bool QSort<T>::greater(const T* const t1, const T* const t2) {
  if ((t1 == t2) || (t2 == 0))
    return false;
  if (t1 == 0)
    return true;
  return bool((*t1) > (*t2));
}

template<class T>
  bool QSort<T>::greateq(const T* const t1, const T* const t2) {
  if ((t1 == t2) || (t1 == 0))
    return true;
  if (t2 == 0)
    return false;
  return bool((*t1) >= (*t2));
}

#endif
