#ifndef _CLASS_QSORT_H_
#define _CLASS_QSORT_H_

//
//  File QSort.H
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "common.H"

#include "Array.H"

// Class QSort performs a quick sort of the elements of an Array
// through its sort() method. Null elements are considered greater
// than any other element.
//

template<class T> class QSort {
  public:
    QSort(Array<T>& a);
    virtual ~QSort();
    void sort();
    Array<T>& array();
  protected:
    Array<T>& a;
    static bool greater(const T* const t1, const T* const t2);
    static bool greateq(const T* const t1, const T* const t2);
    void qsort(const int i, const int j);
    int pivot(const int i, const int j);
  private:
    QSort(const QSort<T> &);
};

#ifdef __GNUG__
#include "QSort.C"
#endif

#endif
