//
//  File SBoolean.C
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91192 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "SBoolean.H"
#include <ctype.h>
#include <string.h>

const char SBoolean::trueStr[] = "true";
const char SBoolean::falseStr[] = "false";

SBoolean::SBoolean(const bool b)
		: isTrue(b ? true : false) {
}

SBoolean::SBoolean(const SBoolean& sb)
		: isTrue(sb.isTrue) {
}

SBoolean::operator bool() const {
	return isTrue;
}

SBoolean& SBoolean::operator=(const bool b) {
	isTrue = b ? true : false;
	return *this;
}

ostream& operator<<(ostream& o, const SBoolean& b) {
  if (b.isTrue)
    o << SBoolean::trueStr;
  else
    o << SBoolean::falseStr;
  return o;
}

istream& operator>>(istream& i, SBoolean& b) {
  char c;
  unsigned j = 0;
  const char* str = 0;
  bool done = false;
  
  if (!i.good())
    return i;
  if (i.flags() & ios::skipws)
    i >> ws;
  
  while(!done && i.get(c)) {
    if (str == 0) {
      switch(tolower(c)) {
        case 't':
          str = SBoolean::trueStr;
          j++;
          break;
        case 'f':
          str = SBoolean::falseStr;
          j++;
          break;
        default:
          i.putback(c);
          i.clear(i.rdstate() | ios::failbit);
          break;
      }
    }else {
      if (tolower(c) != str[j++]) {
        i.putback(c);
        i.clear(i.rdstate() | ios::badbit);
      } else {
        if (j >= strlen(str)) {
          if (str == SBoolean::trueStr)
            b.isTrue = true;
          else
            b.isTrue = false;
          done = true;
        }
      }
    }
  }
  return i;
}
