#ifndef _CLASS_SSCHEDULER_H_
#define _CLASS_SSCHEDULER_H_

//
//  File SScheduler.H
//
//  November 1994 - for Ptolemy (class Scheduler already exists)
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "common.H"
#include "Array.H"

class Synchronous;
class InputSignal;
class OutputSignal;
class Connect;

//
// Class SScheduler
//

class SScheduler {
  private:
    Array<Synchronous> modules;
    Array<Synchronous> newModules;
    Array<Synchronous> delModules;
    Array<Connect> connections;
    bool dirty;
    bool iShouldStop;
    const char* const fName;
    bool fSimul;
    bool fDebug;
    void cleanup();
    SScheduler(const SScheduler&);

  public:
    SScheduler(const char* const name = "SScheduler",
              const bool simul = false,
              const bool debug = false);
    virtual ~SScheduler();
    virtual bool tick();
    virtual void stop();
    virtual void manage(Synchronous *s);
    virtual void trash(Synchronous* s);
    virtual void connect(InputSignal *f, OutputSignal *t);
    virtual void backup();
    virtual void restore();
};

extern SScheduler *theScheduler;

#endif

// End of file SScheduler.H
