#ifndef _CLASS_SSTRING_H_
#define _CLASS_SSTRING_H_

//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

#include <iostream.h>
#include <strstream.h>

class SString {
  public:
    SString(const char* s);
    SString(const SString& s);
    SString();
    virtual ~SString();
    operator char*() const;
    int length() const;
    char& operator[](const int i);
    int operator>(const SString& s) const;
    int operator<(const SString& s) const;
    int operator==(const SString& s) const;
    int operator!=(const SString& s) const;
    int operator>=(const SString& s) const;
    int operator<=(const SString& s) const;
    SString& operator=(const SString& s);
    SString& operator<<(const SString& s);  // Concatenation
    friend ostream& operator<<(ostream& o, const SString& s);
    friend istream& operator>>(istream& i, SString& s);
  private:
    char* buf;
};

#endif
