#ifndef _POINT_H_
//
//  File Point.H
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync demos
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#define _POINT_H_

#include <iostream.h>

class Point {
  private:
    int px;
    int py;
  public:
    Point();
    Point(const int xi, const int yi);
    int operator==(const Point& a) const;
    Point operator-(const Point& a) const;
    Point operator+(const Point& a) const;
    Point nextToward(const Point& a) const;
    int x() const;
    int y() const;
    double dist(const Point& a) const;
    friend ostream& operator<<(ostream& o, const Point& a);
    friend istream& operator>>(istream& i, Point& a);
};

#endif
