#include "XDisplay.H"
#include <string.h>
#include <iostream.h>
#include <stdlib.h>

XDisplay::XDisplay(int opendisp) {
  name = "";
  if (opendisp != 0)
    if (!open()) {
      cerr << "## XDisplay: cannot open display" << name << endl;
      exit(1);
    }
}

XDisplay::XDisplay(char* dispname, int opendisp) {
  name = strcpy(new (char[strlen(dispname)+1]), dispname);
  if (opendisp != 0)
    if (!open()) {
      cerr << "## XDisplay: cannot open " << name << endl;
      exit(1);
    }
}

XDisplay::~XDisplay() {
  close();
  delete[] name;
}

int XDisplay::open() {
  xdisp = XOpenDisplay(name);
  return (xdisp != 0);
}

void XDisplay::close() {
  XCloseDisplay(xdisp);
}

int XDisplay::screenCount() {
  return XScreenCount(xdisp);
}

Display* XDisplay::xdisplay() const {
  return xdisp;
}
