#include "XScreen.H"

XScreen::XScreen(XDisplay& display)
    : disp(display),
      xs(XDefaultScreen(disp.xdisplay())),
      white(XWhitePixel(disp.xdisplay(), xs)),
      black(XBlackPixel(disp.xdisplay(), xs))
{}

XScreen::XScreen(XDisplay& display, int screenNum)
    : disp(display),
      xs(screenNum),
      white(XWhitePixel(disp.xdisplay(), xs)),
      black(XBlackPixel(disp.xdisplay(), xs))
{}

const unsigned long XScreen::whitePixel() const {
  return white;
}

const unsigned long XScreen::blackPixel() const {
  return black;
}

const XDisplay& XScreen::display() const {
  return disp;
}

const int XScreen::xscreen() const {
  return xs;
}
