#ifndef _XTURTLE_H_
//
//  File XTurtle.H
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync demos
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#define _XTURTLE_H_

#include "libSync.H"
#include "Point.H"
#include "XGC.H"

class XTurtle : public Synchronous {
  public:
    XTurtle(const char* name, const XWindow& w,
        const XGC& gc, int step, int margin = 0,
        int radius = 0, const bool Schedule = true);
    const InputSignal** inSigList() const;
    const OutputSignal** outSigList() const;
    virtual InSignal<Point>& probe();
    void resetInputs();
    void resetOutputs();
    void setInputs();
    void activate();
    void backup();
    void restore();
  private:
    const XWindow& myWind;
    const XGC& myGC;
    const int myStep;
    const int myMargin;
    const int myRadius;
    Point lastPos;
    boolean hasLast;
    InSignal<Point> fProbe;
    XTurtle *_pf_backup_copy_;
};

#endif
