#include "XWindow.H"

const int XWindow::kDefBorder = 2;

XWindow::XWindow(const XScreen& s)
    : sc(s),
      xwin(XRootWindow(s.display().xdisplay(), s.xscreen()))
{}

XWindow::XWindow(const XWindow& parent, XSizeHints& hints, const char* name)
    : sc(parent.screen()),
      xwin(XCreateSimpleWindow(sc.display().xdisplay(),
          parent.xwindow(),
        hints.x, hints.y, hints.width, hints.height,
        kDefBorder, sc.blackPixel(), sc.whitePixel()))
{
  XSetStandardProperties(sc.display().xdisplay(),
                         xwin,
                         name, name, None, 0, 0, &hints);
}

XWindow::~XWindow() {
  XDestroyWindow(sc.display().xdisplay(), xwin);
}

const XScreen& XWindow::screen() const {
  return sc;
}

const Window XWindow::xwindow() const {
  return xwin;
}

void XWindow::mapRaised() const {
  XMapRaised(sc.display().xdisplay(), xwin);
}

void XWindow::unmap() const {
  XUnmapWindow(sc.display().xdisplay(), xwin);
}
