//
//  File AsyncEmit.C
//
//  September 3 1992 - January 21 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  which is copyright Ecole Superieure d'Electricite, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by the Ecole Superieure
//       d'Electricite and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//  Neither the name of the Ecole Superieure d'Electricite nor the names of its
//  contributors may be used to endorse or promote products derived from this
//  software without specific prior written permission.
//
//     THIS SOFTWARE MAY NOT BE USED FOR DIRECT COMMERCIAL ADVANTAGE WITHOUT
//     SPECIFIC PRIOR WRITTEN PERMISSION.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "AsyncEmit.H"

template<class sigType>
  AsyncEmit<sigType>::AsyncEmit(const char* name, const boolean schedule)
            : Synchronous(name, schedule),
            fIn(this, "out"),
            fEvent(false)
{
}

template<class sigType>
  sigType& AsyncEmit<sigType>::get() {
    fEvent = false;
    return fRecent;
}

template<class sigType>
  boolean AsyncEmit<sigType>::event() const {
  return fEvent;
}

template<class sigType>
  const InputSignal** AsyncEmit<sigType>::inSigList() const {
  const InputSignal** inList;
  
  inList = new (const InputSignal*[2]);
  inList[0] = &fIn;
  inList[1] = 0;
  return inList;
}

template<class sigType>
  const OutputSignal** AsyncEmit<sigType>::outSigList() const {
  const OutputSignal** outList;
  
  outList = new (const OutputSignal*[1]);
  outList[0] = 0;
  return outList;
}

template<class sigType>
  InSignal<sigType>& AsyncEmit<sigType>::input() {
    return fIn;
}

template<class sigType>
  InSignal<sigType>& AsyncEmit<sigType>::operator()() {
    return fIn;
}

template<class sigType>
  void AsyncEmit<sigType>::resetOutputs() {
}

template<class sigType>
  void AsyncEmit<sigType>::setInputs() {
  fIn.update();
}

template<class sigType>
  void AsyncEmit<sigType>::activate() {
  if (fIn.value().isPresent()) {
    fRecent = fIn.value().value();
    fEvent = true;
  }
}
