//
//  File AsyncRecept.C
//
//  September 3 1992 - January 21 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  which is copyright Ecole Superieure d'Electricite, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by the Ecole Superieure
//       d'Electricite and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//  Neither the name of the Ecole Superieure d'Electricite nor the names of its
//  contributors may be used to endorse or promote products derived from this
//  software without specific prior written permission.
//
//     THIS SOFTWARE MAY NOT BE USED FOR DIRECT COMMERCIAL ADVANTAGE WITHOUT
//     SPECIFIC PRIOR WRITTEN PERMISSION.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "AsyncRecept.H"
#include "AsyncEmit.H"

template<class sigType>
  AsyncRecept<sigType>::AsyncRecept(const char* name, const boolean schedule)
                       : Synchronous(name, schedule),
                         fOut(this, "out"),
                         fSource(0)
{
}

template<class sigType>
  void AsyncRecept<sigType>::getFrom(AsyncEmit<sigType> *source) {
  fSource = source;
}

template<class sigType>
  const InputSignal** AsyncRecept<sigType>::inSigList() const {
  const InputSignal** inList;
  
  inList = new (const InputSignal*[1]);
  inList[0] = 0;
  return inList;
}

template<class sigType>
  const OutputSignal** AsyncRecept<sigType>::outSigList() const {
  const OutputSignal** outList;
  
  outList = new (const OutputSignal*[2]);
  outList[0] = &fOut;
  outList[1] = 0;
  return outList;
}

template<class sigType>
  OutSignal<sigType>& AsyncRecept<sigType>::output() {
    return fOut;
}

template<class sigType>
  OutSignal<sigType>& AsyncRecept<sigType>::operator()() {
    return fOut;
}

template<class sigType>
  void AsyncRecept<sigType>::resetOutputs() {
  fOut.value().reset();
}

template<class sigType>
  void AsyncRecept<sigType>::setInputs() {
  if (fSource->event())
    fOut.value() = fSource->get();
}

template<class sigType>
  void AsyncRecept<sigType>::activate() {
}
