//
//  File AsyncRecept.H
//
//  September 3 1992 - January 21 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  which is copyright Ecole Superieure d'Electricite, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by the Ecole Superieure
//       d'Electricite and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//  Neither the name of the Ecole Superieure d'Electricite nor the names of its
//  contributors may be used to endorse or promote products derived from this
//  software without specific prior written permission.
//
//     THIS SOFTWARE MAY NOT BE USED FOR DIRECT COMMERCIAL ADVANTAGE WITHOUT
//     SPECIFIC PRIOR WRITTEN PERMISSION.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#ifndef _CLASS_ASYNCRECEPT_H_
#define _CLASS_ASYNCRECEPT_H_

#include "common.H"
#include "Synchronous.H"
#include "Signal.H"

#include "AsyncEmit.H"

template<class sigType>
class AsyncRecept : public Synchronous {
  private:
    AsyncEmit<sigType>* fSource;
    OutSignal<sigType> fOut;
  public:
    AsyncRecept(const char* name = "AsyncRecept",
                const boolean schedule = true);
    virtual void getFrom(AsyncEmit<sigType> *source);
    virtual const InputSignal** inSigList() const;
    virtual const OutputSignal** outSigList() const;
    virtual OutSignal<sigType>& output();
    virtual OutSignal<sigType>& operator()();
    void resetOutputs();
    void setInputs();
    void activate();
};

#endif
