//
//  File HSort.H
//
//  September 3 1992 - February 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  which is copyright Ecole Superieure d'Electricite, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by the Ecole Superieure
//       d'Electricite and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//  Neither the name of the Ecole Superieure d'Electricite nor the names of its
//  contributors may be used to endorse or promote products derived from this
//  software without specific prior written permission.
//
//     THIS SOFTWARE MAY NOT BE USED FOR DIRECT COMMERCIAL ADVANTAGE WITHOUT
//     SPECIFIC PRIOR WRITTEN PERMISSION.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#ifndef _HSORT_H_
#define _HSORT_H_

#include "common.H"

#include "Array.H"

// Class HSort performs a heap sort of the elements of
// an Array through its sort() method.
// Null elements are considered greater than any other element.
//

template<class T> class HSort {
  public:
    HSort(Array<T>& a);
    ~HSort();
    void sort();
    Array<T>& array();
  protected:
    Array<T>& a;
    boolean greater(const T* const t1, const T* const t2) const;
    boolean greateq(const T* const t1, const T* const t2) const;
    int root() const { return 0; };
    int father(const int i) const { return ((i+1)/2 - 1); };
    int lson(const int i) const { return (2*i+1); };
    int rson(const int i) const { return (2*(i+1)); };
    void buildheap(int i);
    void removemax(int& nbelt, T*& max);
};

#endif
