#include "Demultiplexer.H"
#include "PureDemult.H"
#include "Merger.H"
#include "PureEncode.H"
#include "PureMerge.H"

class AddMerge : public Merger<int> {
  public:
    AddMerge(const char* name, const int nbInput):Merger<int>(name, nbInput) {}
  protected:
    int combine(const int& oldval, const int& newval) {
      return oldval+newval;
    }
};

class HighestEncode : public PureEncode<int> {
  public:
    HighestEncode(const char* name, const int nbInp):PureEncode<int>(name, nbInp) {}
  protected:
    int encode(const int inpNum, const int& curVal) {
      if (inpNum > curVal)
        return inpNum;
      else
        return curVal;
    }
    
    int defaultcode(const int inpNum) {
      return inpNum;
    }
};


int main() {
  Demultiplexer<int> dmux("dmux",10);
  PureDemult pdmux("pdmux", 15);
  AddMerge mrg("mrg", 7);
  HighestEncode henc("henc", 10);
  PureMerge pmrg("pmrg", 12);
  return 0;
}

#ifdef __DECCXX
#include "Demultiplexer.C"
#include "Merger.C"
#include "PureEncode.C"

#pragma define_template Demultiplexer<int>
#pragma define_template Merger<int>
#pragma define_template PureEncode<int>

#endif
