#ifndef _CLASS_XINTERFACE_C_
#define _CLASS_XINTERFACE_C_

//
//  File XInterface.C
//
//  July 1994 - September 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "XInterface.H"

template<class sigType>
	XInterface& plug(XInterface& x,InSignal<sigType>& s) {
		ostrstream buf;
		buf << s.name() << ends;
		InputModule<sigType> *i = new InputModule<sigType>("","",true,buf.str(),false);
		strstream *t = new strstream;
	
		x.fInModules[x.fNbInputs] = i;
		x.fInStreams[x.fNbInputs] = t;
		i->setStreams(*t, nullDev, nullDev);
		x.fInNames[x.fNbInputs] = buf.str();
		x.fInPure[x.fNbInputs] = new int(XInterface::eValued);
		s << (*i)();
		x.fNbInputs++;
		return x;
	}

template<class sigType>
	XInterface& plug(XInterface& x,InSignal<sigType>& s, const char* nickname) {
		ostrstream buf;
		buf << nickname << ends;
		InputModule<sigType> *i = new InputModule<sigType>("","",true,buf.str(),false);
		strstream *t = new strstream;
	
		x.fInModules[x.fNbInputs] = i;
		x.fInStreams[x.fNbInputs] = t;
		i->setStreams(*t, nullDev, nullDev);
		x.fInNames[x.fNbInputs] = buf.str();
		x.fInPure[x.fNbInputs] = new int(XInterface::eValued);
		s << (*i)();
		x.fNbInputs++;
		return x;
	}

template<class sigType>
	XInterface& plug(XInterface& x,OutSignal<sigType>& s) {
		ostrstream buf;
		buf << s.name() << ends;
		OutputModule<sigType> *o = new OutputModule<sigType>("",true,"",buf.str(),false);
		x.fClock->manage(o);
		strstream *t = new strstream;
	
		x.fOutStreams[x.fNbOutputs] = t;
		o->setStreams(*t, nullDev);
		x.fOutNames[x.fNbOutputs] = buf.str();
		x.fOutPure[x.fNbOutputs] = new int(XInterface::eValued);
		(*o)() << s;
		x.fNbOutputs++;
		return x;
	}

template<class sigType>
	XInterface& plug(XInterface& x,OutSignal<sigType>& s, const char* nickname) {
		ostrstream buf;
		buf << nickname << ends;
		OutputModule<sigType> *o = new OutputModule<sigType>("",true,"",buf.str(),false);
		x.fClock->manage(o);
		strstream *t = new strstream;
	
		x.fOutStreams[x.fNbOutputs] = t;
		o->setStreams(*t, nullDev);
		x.fOutNames[x.fNbOutputs] = buf.str();
		x.fOutPure[x.fNbOutputs] = new int(XInterface::eValued);
		(*o)() << s;
		x.fNbOutputs++;
		return x;
	}

#ifdef __GNUG__
#define _GNUG_DECLARE_PLUG_(T) \
XInterface& plug(XInterface& x, InSignal<##T##>& s); \
XInterface& plug(XInterface& x, InSignal<##T##>& s, const char *nickname); \
XInterface& plug(XInterface& x, OutSignal<##T##>& s); \
XInterface& plug(XInterface& x, OutSignal<##T##>& s, const char *nickname);
#endif

#endif
