//
//  File commonTypes.C
//
//  September 3 1992 - October 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

// This file is used to trigger the instanciation of templates for
// common types: int short long float double SBoolean char* void*
// The instanciation files are put in libSync.a to avoid template
// instanciation when compiling programs that only use those types.
// WARNING: It works only with CC (thanks to ptlink). For cxx,
// use Templates.C to trigger instanciation of templates.

#include "Constant.H"
#include "Delay.H"
#include "IOModule.H"
#include "SBoolean.H"
#include "SString.H"
#include "XInterface.H"

int main() {
  XInterface x(0,0,"dummy");
  
  Constant<int> c_i(0);
  Delay<int> d_i;
  InputModule<int> im_i;
  OutputModule<int> om_i;
  plug(x,im_i());
  plug(x,im_i(),"z");
  plug(x,om_i());
  plug(x,om_i(),"z");

  Constant<SBoolean> c_b(true);
  Delay<SBoolean> d_b;
  InputModule<SBoolean> im_b;
  OutputModule<SBoolean> om_b;
  plug(x,im_b());
  plug(x,im_b(),"z");
  plug(x,om_b());
  plug(x,om_b(),"z");

  Constant<float> c_f(3.14);
  Delay<float> d_f;
  InputModule<float> im_f;
  OutputModule<float> om_f;
  plug(x,im_f());
  plug(x,im_f(),"z");
  plug(x,om_f());
  plug(x,om_f(),"z");

  Constant<double> c_d(3.14);
  Delay<double> d_d;
  InputModule<double> im_d;
  OutputModule<double> om_d;
  plug(x,im_d());
  plug(x,im_d(),"z");
  plug(x,om_d());
  plug(x,om_d(),"z");

  Constant<SString> c_s("");
  Delay<SString> d_s;
  InputModule<SString> im_s;
  OutputModule<SString> om_s;
  plug(x,im_s());
  plug(x,im_s(),"z");
  plug(x,om_s());
  plug(x,om_s(),"z");

  return 0;
}
