//
//  File coreArray.C
//
//  September 3 1992 - August 1994
//
//  Frederic Boulanger - boulange@supelec.fr
//  Ecole Superieure d Electricite - Service Informatique
//  Plateau de Moulon - 91190 Gif sur Yvette cedex
//  France
//
//  This file is part of the libSync synchronous library
//  Copyright Supelec, 1992-1994.
//  All Rights Reserved.
//  
//  Redistribution and use are permitted provided that:
//    - distributions including source files retain this entire copyright
//      notice and comment,
//    - distributions including binaries display the following acknolegment :
//      "This product includes software developped by Supelec
//       and its contributors" in the documentation or other
//      materials provided with the distribution and in all advertising materials
//      mentionning features or use of this software.
//
//     THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED
//     WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
//     MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
//
//
//  Author: Frederic Boulanger (Frederic.Boulanger@supelec.fr)

#include "Array.H"

// VArray : Base class for Arrays of any type
//

VArray::VArray(const int size, const int chunk)
       : kChunk(chunk),
         fSize(size)
{
  calcAlloc(fSize);
}

VArray::VArray(const VArray& v) 
        : kChunk(v.kChunk),
          fAlloc(v.fAlloc),
          fSize(v.fSize) {
  
}

int VArray::size() const {
  return fSize;
}

int VArray::checkSize(const int i) {
  if (i < fSize)
    return i;
  resize(i + 1);
  return i;
}

void VArray::calcAlloc(const int size) {
  if (size == 0)
    fAlloc = 1;
  else {
    fAlloc = size / kChunk;
    if ((size % kChunk) != 0)
      fAlloc++;
  }
}

