#include "libSync.H"

int main() {
  cerr << "This is a test program for constants." << endl;
  cerr << "A pure constant and an integer constant will be initialized." << endl;
  cerr << "You can choose between permanently emiting constants and one" << endl;
  cerr << "shot constants." << endl << endl;
  
  PureInModule pi("Pure signal value ('+', '-', \"present\" ou \"not present\"): ");
  pi.react();
  PureSample p(pi().value());

  InputModule<int> ii("Integer signal value: ");
  while(!ii().value().isPresent())
    ii.react();
  int i(ii().value().value());

  InputModule<boolean> bi("Emiting (true) or one-shot (false) constants : ");
  while(!bi().value().isPresent())
    bi.react();
  boolean b(bi().value().value());

  SScheduler clock;
  PureConstant pc(p,b);
  Constant<int> ic(i,b);
  PureOutModule po("Pure signal: ");
  OutputModule<int> io("Integer signal: ");
  
  po() << pc();
  io() << ic();
  
  cerr << endl << "Go for 5 ticks..." << endl;
  
  for(int j=0; j<5; j++)
    clock.tick();
  
  return 0;
}
