#include "libSync.H"
#include "brake.H"

int main() {
  cerr << "This is a test program for the clock and input/output modules." << endl;
  cerr << "This program simulates a brake. You enter the command" << endl;
  cerr << "and it yields the output pressure, which is equal to the" << endl;
  cerr << "command. The input and output modules log their activity" << endl;
  cerr << "in the file \"brake.log\". In this program, the clock runs" << endl;
  cerr << "in debug mode, so you can control the tick and stop the clock." << endl;
  cerr << endl;

  SScheduler myClock("Clock", true);  // Side-effect: theScheduler = &myClock;
  Brake frein("Frein");
  
  InputModule<int> pedale("Command : ");
  OutputModule<int> machoire("Pression : ");

#ifndef _VX_WORKS_
  ofstream logFile("brake.log");

  pedale.setStreams(cin,cout,logFile);
  machoire.setStreams(cout,logFile);
#endif

  frein.Command() << pedale.input();
  machoire.probe() << frein.Pressure();

  while(myClock.tick())
    ;

  return 0;
}
